﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace csharp_trials
{

    class Product
    {
        public Product(string name, int newID)
        {
            ItemName = name;
            ItemID = newID;
        }

        public string ItemName;
        public int ItemID;
    }

    class ValueVsReference
    {


        private static void ChangeByReference(ref Product itemRef)
        {
            // Change the address that is stored in the itemRef parameter.   
            itemRef = new Product("Stapler", 99999);

            // You can change the value of one of the properties of
            // itemRef. The change happens to item in Main as well.
            itemRef.ItemID = 12345;
        }

        private static void ChangeByObject(Product itemRef)
        {
            // Change the address that is stored in the itemRef parameter.   
            itemRef = new Product("ehrjhe", 99999);

            // You can change the value of one of the properties of
            // itemRef. The change happens to item in Main as well.
            itemRef.ItemID = 22222;
        }

        private static void Main()
        {
            int x = 13;
            System.Console.WriteLine("Original Value of X is : {0}", x);

            ChangeData(x);

            System.Console.WriteLine("Changed Value of X is : {0}\n", x);

            System.Console.WriteLine("===============================\n");

            // Declare an instance of Product and display its initial values.
            Product item = new Product("Fasteners", 54321);
            System.Console.WriteLine("Original values in Main.  Name: {0}, ID: {1}\n",
                item.ItemName, item.ItemID);


            ChangeObjectData(item);
            System.Console.WriteLine("Back in Main.  Name: {0}, ID: {1}\n",
                item.ItemName, item.ItemID);

            ChangeByObject(item);
            System.Console.WriteLine("Back in Main.  Name: {0}, ID: {1}\n",
                item.ItemName, item.ItemID);
          
            // Pass the product instance to ChangeByReference.
            ChangeByReference(ref item);
            System.Console.WriteLine("Back in Main.  Name: {0}, ID: {1}\n",
                item.ItemName, item.ItemID);
        }

        private static void ChangeData(int x)
        {
            x++;
        }

        private static void ChangeObjectData(Product item)
        {
            item.ItemName = "Changed Name";
        }

        // This method displays the following output:
        // Original values in Main.  Name: Fasteners, ID: 54321
        // Original values in Main.  Name: Fasteners, ID: 54321
        // Back in Main.  Name: Stapler, ID: 12345

    }
}
